package loderunner;

import java.awt.*;
import java.applet.Applet;
import java.io.*;
import java.util.*;

import java.awt.event.*;


public class Game extends Applet implements KeyListener {

    final static int e01 = 01;	//   UP
    final static int e02 = 02;	//   DOWN
    final static int e03 = 03;	//   LEFT
    final static int e04 = 04;	//   RIGHT
    final static int e05 = 05;	//   SPACE/HOLE
    final static int e06 = 06;	//   ESC	
    final static int e00 = 00;	//   
    final static int e10 = 10;	//  
	
    //   A0
    private final int y00 = 0; 
    private final int y01 = 1; 
    private final int y02 = 2;
    private final int y03 = 3;
    private int state = y00; //  
	
    private final int infoHeight = 10;
    private final Font font = new Font("Serif", Font.PLAIN|Font.ITALIC, 30);
    private Image buffer,sbuffer;  
    private Level level;		  
    private Image picture;
    private Image rImages[];
    private Image eImages[];
    private Image coreImages[];
    public static Image holeImages[];
    public static Image lode;

    private Man [] men;
    private int levelIndex;
    private int keyPressed;
    private Timer timer;
    private boolean isWaiting  = false;

    public static Logger logger = new Logger();
    
    private void initBuffer(int w,int h){
        buffer = createImage (w, h);
    }

//   
    public void loadImages() {
        MediaTracker mt;
        mt = new MediaTracker(this);	
		
        coreImages = new Image[4];
        coreImages[0] = getImage(getDocumentBase(),"Images/brick1.gif");		
        coreImages[1] = getImage(getDocumentBase(),"Images/brick2.gif");				
        coreImages[2] = getImage(getDocumentBase(),"Images/stair.gif");	
        coreImages[3] = getImage(getDocumentBase(),"Images/clue.gif");		

        rImages = new Image[15];
        rImages[0] =  getImage(getDocumentBase(),"Images/runner0.gif");
		
        rImages[1] =  getImage(getDocumentBase(),"Images/runner-right1.gif");				
        rImages[2] =  getImage(getDocumentBase(),"Images/runner-right2.gif");				
        rImages[3] =  getImage(getDocumentBase(),"Images/runner-right3.gif");				
        rImages[4] =  getImage(getDocumentBase(),"Images/runner-left1.gif");				
        rImages[5] =  getImage(getDocumentBase(),"Images/runner-left2.gif");				
        rImages[6] =  getImage(getDocumentBase(),"Images/runner-left3.gif");				

        rImages[7] =  getImage(getDocumentBase(),"Images/rope-right1.gif");				
        rImages[8] =  getImage(getDocumentBase(),"Images/rope-right2.gif");				
        rImages[9] =  getImage(getDocumentBase(),"Images/rope-right3.gif");				
        rImages[10] =  getImage(getDocumentBase(),"Images/rope-left1.gif");				
        rImages[11] =  getImage(getDocumentBase(),"Images/rope-left2.gif");				
        rImages[12] =  getImage(getDocumentBase(),"Images/rope-left3.gif");				
        rImages[13] =  getImage(getDocumentBase(),"Images/stairs1.gif");
        rImages[14] =  getImage(getDocumentBase(),"Images/stairs2.gif");				
        
        eImages = new Image[15];
        eImages[0] =  getImage(getDocumentBase(),"Images/enemy0.gif");
		
        eImages[1] =  getImage(getDocumentBase(),"Images/enemy-right1.gif");				
        eImages[2] =  getImage(getDocumentBase(),"Images/enemy-right2.gif");				
        eImages[3] =  getImage(getDocumentBase(),"Images/enemy-right3.gif");				
        eImages[4] =  getImage(getDocumentBase(),"Images/enemy-left1.gif");				
        eImages[5] =  getImage(getDocumentBase(),"Images/enemy-left2.gif");				
        eImages[6] =  getImage(getDocumentBase(),"Images/enemy-left3.gif");				

        eImages[7] =  getImage(getDocumentBase(),"Images/enemy-rope-right1.gif");				
        eImages[8] =  getImage(getDocumentBase(),"Images/enemy-rope-right2.gif");				
        eImages[9] =  getImage(getDocumentBase(),"Images/enemy-rope-right3.gif");				
        eImages[10] =  getImage(getDocumentBase(),"Images/enemy-rope-left1.gif");				
        eImages[11] =  getImage(getDocumentBase(),"Images/enemy-rope-left2.gif");				
        eImages[12] =  getImage(getDocumentBase(),"Images/enemy-rope-left3.gif");				
        eImages[13] =  getImage(getDocumentBase(),"Images/enemy-stairs1.gif");
        eImages[14] =  getImage(getDocumentBase(),"Images/enemy-stairs2.gif");				
        
        picture  = getImage(getDocumentBase(),"Images/picture.gif");
        lode  = getImage(getDocumentBase(),"Images/lode.gif");		

        holeImages = new Image[6];
        holeImages[0] = getImage(getDocumentBase(),"Images/hole0.gif");				
        holeImages[1] = getImage(getDocumentBase(),"Images/hole1.gif");				
        holeImages[2] = getImage(getDocumentBase(),"Images/hole2.gif");				
        holeImages[3] = getImage(getDocumentBase(),"Images/hole3.gif");				
        holeImages[4] = getImage(getDocumentBase(),"Images/hole4.gif");
        holeImages[5] = getImage(getDocumentBase(),"Images/hole5.gif");				
		
        for (int i = 0; i < holeImages.length; i++ ) mt.addImage(holeImages[i], 0);				
        for (int i = 0; i < coreImages.length; i++ ) mt.addImage(coreImages[i], 0);				
        for (int i = 0; i < rImages.length; i++ ) mt.addImage(rImages[i], 0);		
        for (int i = 0; i < eImages.length; i++ ) mt.addImage(eImages[i], 0);		
        mt.addImage(picture,0);
        mt.addImage(lode,0);
							
        try {
            mt.waitForAll();
        }
        catch (InterruptedException ex)	{
            System.err.println("   ");
        }
    }
	
    public void init()	{        
        //   
        initBuffer(this.getSize().width,this.getSize().height);		
        this.setFont(font);
        this.setBackground (Color.black);
        buffer.getGraphics().fillRect (0, 0, this.getSize().width ,this.getSize().height);
        buffer.getGraphics().setColor(Color.yellow);
        this.setForeground(Color.yellow);
        String str = "Initializing ...";
        buffer.getGraphics().drawString (str,(this.getSize().width - this.getGraphics ().getFontMetrics(this.getFont()).stringWidth (str))/2,this.getSize().height/2);
        this.setForeground (Color.black);
        repaint();				

        // 
        loadImages();        
        logger.setWritable( "true".equals(this.getParameter("log")));
        //  
        this.addKeyListener (this);		
    }
	
    public void start() {
        A0(e00);
    } 
	
// 
    private void loadLevel() throws IOException {
        Color c = this.getForeground();
        Font f = this.getFont();                
        this.setForeground  (Color.black);

        buffer.getGraphics().fillRect (0, 0, this.getSize().width ,this.getSize().height);
        this.setForeground(Color.yellow);
        this.setFont(font);
        String str = "Loading Level " + levelIndex + "...";
        buffer.getGraphics().drawString (str,(this.getSize().width - this.getGraphics ().getFontMetrics(this.getFont()).stringWidth (str))/2,this.getSize().height/2);
        this.setForeground  (Color.black);		
        repaint();				
        try {					
            //level = new Level(this.getCodeBase(),coreImages,rImages);
            level.loadLevel("levels/level"+levelIndex+".lev"); 
            buffer.getGraphics ().dispose ();

            this.resize(level.getWidth () * Level.getCellSize (),level.getHeight () * Level.getCellSize () + infoHeight);

            initBuffer(level.getWidth () * Level.getCellSize (),level.getHeight () * Level.getCellSize () + infoHeight);
            buffer.getGraphics ().setXORMode(Color.black);  
            sbuffer = createImage(buffer.getWidth(null)  , buffer.getHeight(null));
            level.paint(sbuffer.getGraphics ());
            buffer.getGraphics().drawImage(sbuffer,0,0,null);
            men = level.getMen ();
            for (int i = 0; i< men.length; i++ ) men[i].draw(buffer.getGraphics ());					

            // 		
            timer = new Timer();
            timer.schedule(new TimerTask () {   public void run() {
                                                                    A0(e10);                                                                
                                                                   }											 
                                                                 }, 0,55);
            repaint();			
        } catch (IOException ex) {			
            throw ex;
        }
        repaint();				
        this.setForeground(c);
        this.setFont(f);
    }


//----------------------------------------------------------------------------------------
//---   A0-------------------------------------------------------
//----------------------------------------------------------------------------------------

//    ?
    private boolean x00(){	
        if ((men[0].getPos().getInX() == 0)&& (men[0].getPos().getInY() == 0)) return true;
        else return false;
    }
	
//     ?
    private boolean x01(){	
        if (level.isExit(men[0].getPos().getY(),men[0].getPos().getX())) return true;
        else return false;
}

//     ?
    private boolean  x02(){
        timer.cancel();        
        levelIndex++;
        try {
            loadLevel();
        } catch (IOException ex){			
            return false;
        }
        return true;
    }

//  ?
    private boolean x03(){
        for (int i = 1; i < men.length; i++) {
            if (((Enemy)men[i]).isKill()) return true;
        }
        return ((Runner) men[0]).inHole();
    }

//  ?
    private boolean x04(){
        if (((Runner) men[0]).getLives() > 1) return true;
            return false;
    }
    
    
//----------------------------------------------------------------------------------------
//--   A0-----------------------------------------------------
//----------------------------------------------------------------------------------------

// C  Level
    private void z00() {
        logger.log(1, "z00 -   Level");
        level = new Level(this.getCodeBase(),coreImages,rImages, eImages);
    }
    
//     
    private void z01(){		
        logger.log(1, "z01 -     ");
        try{
            loadLevel();
        } catch (IOException ex) {			
            System.out.println (ex);
            System.exit(1);
        }	
    }
    
//   
    private void z02_1() {		
        logger.log(1, "z02_1 -   ");
        buffer.getGraphics().drawImage (sbuffer,0,0,null);				
        buffer.getGraphics().setPaintMode();				
        buffer.getGraphics().setXORMode(Color.black);

        if (level.lodes.size() == 0) { level.showExit(); level.paint(buffer.getGraphics());}

        for (int i  = level.holes.size()-1; i>=0 ; i--){					
            if (((Hole)level.holes.get(i)).isDead) level.holes.remove(i);
        }

        level.paintHoles(buffer.getGraphics());
        level.paintLodes(buffer.getGraphics());

        men[0].draw (buffer.getGraphics());
        for (int i  = 1; i < men.length; i++){            
            men[i].draw (buffer.getGraphics());
        }                                                                
        String str = "level:" + levelIndex + "   boxes: " + level.lodes.size() + "   lives: " + ((Runner) men[0]).getLives();
        buffer.getGraphics().drawString (str, 2, -2 + buffer.getHeight(null));
        paint(this.getGraphics ());
    }
	
//  
    private void z02_2(){
        logger.log(1, "z02_2 -  ");
        this.setForeground(Color.black);
        buffer.getGraphics().fillRect (0, 0, this.getSize().width ,this.getSize().height);
        buffer.getGraphics().drawImage (picture,0,0,null);
        this.setForeground  (Color.red);              
        this.setFont(new Font("Serif", Font.ITALIC, 15));
        String str1 = "press \"space\" to start";
        buffer.getGraphics().drawString(str1, ( -this.getFontMetrics(this.getFont()).stringWidth(str1) + buffer.getWidth(null)) / 2 ,buffer.getHeight(null)/2 + 2);
        this.setFont(new Font("Serif", Font.ITALIC, 12));
        String str = "left - left arrow  right - right arrow  up - up arrow  down - down arrow";            
        String str2 = "(c) Bogdanov Michael, IFMO 2004, flown@bk.ru";            
        buffer.getGraphics().drawString(str, ( -this.getFontMetrics(this.getFont()).stringWidth(str) + buffer.getWidth(null)) / 2 ,buffer.getHeight(null) - this.getFontMetrics(this.getFont()).getHeight() - 10);
        
        buffer.getGraphics().drawString(str2, ( -this.getFontMetrics(this.getFont()).stringWidth(str2) + buffer.getWidth(null)) / 2 ,buffer.getHeight(null) - 10);
        this.setForeground(Color.black);
        repaint();
    }

// 
    private void z02_3() {
        logger.log(1, "z02_3 -  ");
        this.setFont(font);		
        this.setForeground(Color.black);
        buffer.getGraphics().fillRect (0, 0, this.getSize().width ,this.getSize().height);
        this.setForeground(Color.yellow);
        String str = "Game over!!!";
        buffer.getGraphics().drawString (str,(this.getSize().width - this.getGraphics ().getFontMetrics(this.getFont()).stringWidth (str))/2,this.getSize().height/2);

        this.setForeground  (Color.red);              
        this.setFont(new Font("Serif", Font.ITALIC, 15));
        String str1 = "press \"space\" to continue";
        buffer.getGraphics().drawString(str1, ( -this.getFontMetrics(this.getFont()).stringWidth(str1) + buffer.getWidth(null)) / 2 ,buffer.getHeight(null) - 10);
        this.setForeground(Color.black);
        repaint();				
    }
	
//  
    private static int counter = 15;
    private void z03() {
        logger.log(1, "z03 -  ");
        counter--;
        if (counter < 0 ) { counter = 15; level.buildRoutes(men[0].getPos().getX(), men[0].getPos().getY()); }
        for (int i = 1; i < men.length; i++) 
            ((Enemy)men[i]).move();
    }
	

//   
    private void z04(){
        logger.log(1, "z04 -   ");
	if ((men[0].getPos().getInX() == 0)&& (men[0].getPos().getInY() == 0)) {
            for (int i = level.lodes.size()-1; i >= 0 ; i--){
               	if(((Lode)level.lodes.get(i)).isEqual(men[0].getPos().getX(),men[0].getPos().getY())){
                    ((Runner)men[0]).addLode();
                    level.lodes.remove(i);
		}
            }
	}
    }
	
//     
    private void z05(){
        logger.log(1, "z05 -     ");
        isWaiting = true;
        try {                           
            String str1 = "Ooopps...";
            this.setFont(new Font("Serif", Font.ITALIC, 24));
            this.setForeground(Color.red);
            buffer.getGraphics().drawString(str1, ( -this.getFontMetrics(this.getFont()).stringWidth(str1) + buffer.getWidth(null)) / 2 ,buffer.getHeight(null)/2 + 2);
            repaint();
            Thread.currentThread().sleep(1500);
            z09();
        } catch(Exception t) {
            System.out.println("error " + t);
        } 
    }

//  
    private void z06(){
        logger.log(1, "z06 -  ");
        timer.cancel();
    }
    
//    
    private void z07(){ 
        logger.log(1, "z07 -   ");
        levelIndex = 1;        
    }
//  
    private void z08(){
        logger.log(1, "z08 -  ");
        ((Runner)men[0]).subLive();
        men[0].resetAutomat();
    }

//      
    private void z09() {
        logger.log(1, "z09 -  ");
        this.setFont(new Font("Serif", Font.BOLD, 10));
        this.setForeground(Color.red);
    }
    
//  
    private void z10() {        
        logger.log(1, "z10 -  ");
        level.reInitLevel();
        men = level.getMen();        
        timer = new Timer();
        timer.schedule(new TimerTask () {
                                public void run() {
                                    A0(e10);
                                }
                            }, 0,55);
        isWaiting = false;
        keyPressed = e00;
    }

//----------------------------------------------------------------------------------------
//-- A0-  ---------------------------------------------------
//----------------------------------------------------------------------------------------
    private  void A0(final int e) {
        int oldState = state;
        logger.log(" A0    ", e);
        switch (state) {		
            case y00:
                state = y01;			
            break;
			
            case y01:			
                if (e == e05){
                    z01();	
                    state = y02; 
                }
            break;
				
            case y02:  //
                if (e == e10 && x00() && x01() && !x02()) { //
                    state = y03;
                    break;	
                }

                if (e == e10 && x03() && !x04()) {
                    z06();
                    state = y03;
                    break;
                }
                if (e == e10 && x03() && x04()) {
                    z06();
                    z05();
                    z08();
                    z10();
                    z02_1();
                    break;
                }
                if (e == e10 && !x03()) {
                    men[0].A1(keyPressed);
                    z03();
                    z04();
                    z02_1();
                    break;
                }
			
                if (e == e06) {    //  escape
                    z06();
                    state = y01;
                }
            break;
				
            case y03:	//
            	if (e05 == e) {
                    state = y01;
                }			
            break;
        }
		
        if (oldState != state) {
            logger.log(" A0    y0" + oldState + "  0" + state);
		
            switch (state){				
            	case y00:
                break;
				
                case y01:
                    z00();
                    z07();
                    z02_2();
                break;

                case y02:
    	            z09();
                break;
				
                case y03:
                    z02_3();
                break;
            }	
        }
        logger.log(" A0    ", e);
    }
	
	
//  
    public  void paint(Graphics g){
        g.drawImage(buffer, 0, 0, null);
    }
	
	
//  KeyListner

    public void keyPressed(KeyEvent e) {
        if (!isWaiting)
        switch (e.getKeyCode()) {
            case KeyEvent.VK_UP:
                keyPressed = e01;			
                break;
            case KeyEvent.VK_DOWN:
                keyPressed = e02;				
                break;
            case KeyEvent.VK_LEFT:
                keyPressed = e03;
                break;
            case KeyEvent.VK_RIGHT:
                keyPressed = e04;
                break;
            case KeyEvent.VK_SPACE:
                keyPressed = e05;
                if (state == y01) A0(e05);
                break;
            case KeyEvent.VK_ESCAPE :
                keyPressed = e06;                          
                if (state == y02) A0(e06);
                break;
            default:
                keyPressed = e00;                    		
		}
    }
          
    public void keyReleased(KeyEvent e) {
        int key = 0;
        if (!isWaiting) {
            switch (e.getKeyCode()) {
                case KeyEvent.VK_UP:
                    key = e01;				
                    break;
                case KeyEvent.VK_DOWN:
                    key = e02;				
                    break;
                case KeyEvent.VK_LEFT:
                    key = e03;
                    break;
                case KeyEvent.VK_RIGHT:
                    key = e04;
                    break;
                case KeyEvent.VK_SPACE:
                    key = e05;
                    if (state != y02) A0(e05);
                    break;
                case KeyEvent.VK_ESCAPE :
                    key = e06;
                    if (state == y02) A0(e06);
                    break;
                default:
                    key = e00;                    		
            }			            
           if (keyPressed == key) keyPressed = e00;
        }
    }
    
    public void keyTyped(KeyEvent e) {}


    public void destroy(){
    	A0(e06);
    }
}