package loderunner;

import java.awt.*;
import java.util.TreeMap;

/*
 *   .
 */
public class Hole implements Runnable {
    
    private int x, y, cellSize;
    private static int lifeTime = 5000;
    private static int deathTime = 1200;
    private int image;
    private int iSize;
    public boolean isDead = false;
    private boolean isClosing = false;
    
    private Level level;
    private static TreeMap holes = new TreeMap();

    public Hole(int y, int x, Level level){
        this.x = x;
        this.y = y;
        cellSize = Level.getCellSize();			
        image = 0;
        iSize = Game.holeImages.length;
        this.level = level;
        holes.put(new Integer( x + 100 * y), this);
        (new Thread(this)).start();        
    }
	
    public void draw(Graphics g){
        g.drawImage(Game.holeImages[image], x*cellSize, y*cellSize, cellSize, cellSize, null);
    }

    //    (x,y) -  
    public boolean isEqual(int x, int y){
        if((this.x == x) && (this.y ==y)) return true;
        else return false;
    }

//Thread 
    public void run (){
        level.setBoxAT(y,x,Level.HOLE);        
        try {
            Thread.currentThread().sleep(lifeTime);
        } catch (Exception e) {
            e.printStackTrace();
        }
        isClosing = true;
        for (int i = 0; i < iSize - 1; i++ ) {
            image++;
            try {
                Thread.currentThread().sleep(deathTime / iSize);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }        
        isDead = true;
        holes.remove(new Integer(x + 100 * y));        
        level.setBoxAT(y,x,Level.BRICK1);        
    }

//    p,  null,    
    public static Hole getHole(Position p){
        return (Hole) holes.get(new Integer(p.getX() + 100 * p.getY()));        
    }

// true,    
    public boolean isClosing(){
        return isClosing;
    }
} 