package loderunner;

import java.text.*;
import java.util.Date;

/**
 *  Logger -  
 */
public class Logger {

    private boolean writable;
    private SimpleDateFormat sdf;

    public Logger() {
        sdf = new SimpleDateFormat("HH:mm:ss SSS");
        writable = false;
    }

    public void setWritable(boolean b) {
        writable = b;
    }

    public void log (String str) {
        if (writable)
            System.out.println( sdf.format(new Date()) + " - " + str);
    }

    public void log (String str, int e) {
        switch (e) {
            case Game.e10: log (str + " "); break;
            case Game.e06: log (str + "  ESC"); break;
            case Game.e00: log (str + "  "); break;
            case Game.e05: log (str + "  SPACE"); break;
            default: log (str);
        }
    }

    public void log (int i, String str) {
        if (i == 1)
            log ("   " + str );
        else if (i == 2)
            log ("       " + str );
        else log(str);
    }

    public void log (int i, String str, int e) {
        switch (e) {
            case Game.e00: log (i, str + "  "); break;
            case Game.e01: log (i, str + "  "); break;
            case Game.e02: log (i, str + "  "); break;
            case Game.e03: log (i, str + "  "); break;
            case Game.e04: log (i, str + "  "); break;
            case Game.e05: log (i, str + "   "); break;
            case Game.e06: log (i, str + "  ESC"); break;
            default: log (i, str);
        }
    }
}